#ifndef __QTCLPIXMAP_H__
#define __QTCLPIXMAP_H__


#include <qobject.h>
#include <qstring.h>
#include <qptrlist.h>
#include <qstringlist.h>
#include <qpixmap.h>

struct Tcl_Interp;
class QTclInterp;

class QTclPixmapFactory {
public:
  virtual QPixmap create(const QString &name)=0;
  virtual ~QTclPixmapFactory() {}
  virtual QStringList names()=0;
  virtual QString name(const QPixmap pixmap)=0;
};

class QTclGlobalPixmapFactory {
public:
  static QPixmap create(const QString &name);
  static QStringList names();
  static QString name(const QPixmap pixmap);
  static void addPixmapFactory(QTclPixmapFactory *factory);
private:
  static QPtrList<QTclPixmapFactory> factoryList;
};

int QTclPixmapInit(QTclInterp *qinterp);
int QTclGetPixmap(Tcl_Interp *interp,const char *str,QPixmap *pp);
int QTclAppendPixmap(Tcl_Interp *interp,const QPixmap pixmap);
int QTclAppendPixmapPtr(Tcl_Interp *interp,const QPixmap *pixmapPtr);

#endif
